
FUNCTION TF4.FindFirstFree(X:INTEGER):INTEGER;
 VAR
  Y:INTEGER;
 BEGIN
  Y:=Rows;
  Repeat
   Y:=Y-1;
  Until (fGrid[X,Y]=FBACKCOLOR) or (Y=0);
  IF fGrid[X,Y]<>FBACKCOLOR THEN
   Y:=Y-1;
  Result:=Y;
 END;


procedure TF4.Click;
Var TX,Ty: Integer;
    P: TPoint;
begin
 inherited click;
 if fPlaying then
  begin
   GetCursorPos(P);
   P:=ScreenToClient(P);
   Tx:=(P.X div Round(Width/Columns));
   TY:=FINDFIRSTFREE(TX);
 //  SHOWMESSAGE(INTTOSTR(TX)+','+INTTOSTR(TY));
   If TY>-1 then
    begin
     SetBlockAt(tX,Ty,PLAYER[fWhosOnTurn].PCOL);
     IF NOT CheckForWinner(PLAYER[fWhosOnTurn].PCOL) THEN
      BEGIN
       fWhosOnTurn:=NEXTPLAYER;
       IF PLAYER[FWHOSONTURN].KIND =  plComputer THEN
        BEGIN
         CPUMOVE;
         fWhosOnTurn:=NEXTPLAYER;
        END;
      END;
    end
   else
    If Assigned(OnFalseMove) then
     fOnfalseMove(self);
  End
 Else
  MessageBeep(MB_OK);
 If Assigned(OnClick) then
  Onclick(self);
End;

Function TF4.CheckForWinner(K:TCOLOR):Boolean;
 Var
  E:TCOLOR;
  X,Y:Integer;
  Winner:Boolean;
 begin
  IF K=PLAYER[1].PCOL THEN
   E:=HI1
  ELSE
   E:=HI2;
  Winner:=False;
  //  Horizontaal
  For Y:=0 to Rows-1 do
   For X:=0 to Columns-4 do
    If (fGrid[X,Y]=K) and (fGrid[X+1,Y]=K) and (fGrid[X+2,Y]=K) and (fGrid[X+3,Y]=K) then
     BEGIN
      DRAWBLOCK(X,Y,E);
      DRAWBLOCK(X+1,Y,E);
      DRAWBLOCK(X+2,Y,E);
      DRAWBLOCK(X+3,Y,E);
      Winner:=True;
     END;
//  verticaal
  For Y:=0 to Rows-4 do
   For X:=0 to Columns-1 do
    If (fGrid[X,Y]=K) and (fGrid[X,Y+1]=K) and (fGrid[X,Y+2]=K) and (fGrid[X,Y+3]=K) then
     BEGIN
      DRAWBLOCK(X,Y,E);
      DRAWBLOCK(X,Y+1,E);
      DRAWBLOCK(X,Y+2,E);
      DRAWBLOCK(X,Y+3,E);
      Winner:=True;
     END;
//  Diagonaal: \
  For Y:=0 to Rows-4 do
   For X:=0 to Columns-4 do
    If (fGrid[X,Y]=K) and (fGrid[X+1,Y+1]=K) and (fGrid[X+2,Y+2]=K) and (fGrid[X+3,Y+3]=K) then
     BEGIN
      DRAWBLOCK(X,Y,E);
      DRAWBLOCK(X+1,Y+1,E);
      DRAWBLOCK(X+2,Y+2,E);
      DRAWBLOCK(X+3,Y+3,E);
      Winner:=True;
     END;
//  Diagonaal: /
  For Y:=3 to Rows-1 do
   For X:=0 to Columns-4 do
    If (fGrid[X,Y]=K) and (fGrid[X+1,Y-1]=K) and (fGrid[X+2,Y-2]=K) and (fGrid[X+3,Y-3]=K) then
     BEGIN
      DRAWBLOCK(X,Y,E);
      DRAWBLOCK(X+1,Y-1,E);
      DRAWBLOCK(X+2,Y-2,E);
      DRAWBLOCK(X+3,Y-3,E);
      Winner:=True;
     END;
  IF WINNER THEN
   FPLAYING:=FALSE;
  If Winner and Assigned(OnWinGame) then
   Begin
    fonWinGame(self,PLAYER[fWhosOnTurn]);
    fPlaying:=false;
   End;
  Result:=Winner;
end;


Procedure TF4.CPUMove;
 Var
  Can:Boolean;
  X,BestPosition:Integer;
 Begin
  //Check if you can add a new piece
  Can:=FALSE;
  For X:=0 to Columns-1 Do
   Can:=Can OR (FindFirstFree(X) > -1);
  If Can Then // If ther's one or more free Columns
   Begin
    BestPosition:=Find3(PLAYER[fWhosOnTurn].PCOL); //Try To Win
    If BestPosition=-1 then
     BestPosition:=Find3(PLAYER[NEXTPLAYER].PCOL);
    Case FLev of
     ciNormal:If BestPosition=-1 then
               Begin
                BESTPOSITION:=FIND2(PLAYER[fWhosOnTurn].PCOL,PLAYER[NEXTPLAYER].PCOL,PLAYER[fWhosOnTurn].PCOL);
                IF BESTPOSITION=-1 THEN
                 BESTPOSITION:=FIND2(PLAYER[NEXTPLAYER].PCOL,PLAYER[NEXTPLAYER].PCOL,PLAYER[fWhosOnTurn].PCOL);
               END;
     ciEinstein:If BestPosition=-1 then
                 Begin
                  BESTPOSITION:=FIND2(PLAYER[fWhosOnTurn].PCOL,PLAYER[NEXTPLAYER].PCOL,PLAYER[fWhosOnTurn].PCOL);
                  IF BESTPOSITION=-1 THEN
                   BEGIN
                    BESTPOSITION:=FIND2(PLAYER[NEXTPLAYER].PCOL,PLAYER[NEXTPLAYER].PCOL,PLAYER[fWhosOnTurn].PCOL);
                    IF BESTPOSITION=-1 THEN
                     Begin
                      BESTPOSITION:=FIND1(PLAYER[fWhosOnTurn].PCOL,PLAYER[NEXTPLAYER].PCOL,PLAYER[fWhosOnTurn].PCOL);
                      IF BESTPOSITION=-1 THEN
                       BESTPOSITION:=FIND1(PLAYER[NEXTPLAYER].PCOL,PLAYER[NEXTPLAYER].PCOL,PLAYER[fWhosOnTurn].PCOL);
                     End;
                   END;
                 END;
     End;//Case
     IF BESTPOSITION=-1 THEN
      BestPosition:=RandomPosition;
     SetBlockAt(BestPosition,FindFirstFree(BESTPOSITION),PLAYER[fWhosOnTurn].PCOL);
     fPlaying:=Not CheckForWinner(PLAYER[fWhosOnTurn].PCOL);
   End
  Else
   fPlaying:=False;
 End;

Function TF4.Find3(W:TCOLOR):Integer;
 Var
  X,Y,J:Integer;
 Begin
  J:=-1;//Not Found...
  //  Horizontaal
  For Y:=0 to Rows-1 do
   For X:=0 to Columns-4 do
    Begin
     If (FindFirstFree(X)=Y)and(fGrid[X+1,Y]=W)and(fGrid[X+2,Y]=W)and(fGrid[X+3,Y]=W) then
      J:=X;
     If (FindFirstFree(X+1)=Y)and(fGrid[X,Y]=W)and(fGrid[X+2,Y]=W)and(fGrid[X+3,Y]=W) then
      J:=X+1;
     If (FindFirstFree(X+2)=Y)and(fGrid[X+1,Y]=W)and(fGrid[X,Y]=W)and(fGrid[X+3,Y]=W) then
      J:=X+2;
     If (FindFirstFree(X+3)=Y)and(fGrid[X+1,Y]=W)and(fGrid[X+2,Y]=W)and(fGrid[X,Y]=W) then
      J:=X+3;
    End;
  //  verticaal
  For Y:=0 to Rows-4 do
   For X:=0 to Columns-1 do
    If (FindFirstFree(X)=Y)and(fGrid[X,Y+1]=W)and(fGrid[X,Y+2]=W)and(fGrid[X,Y+3]=W) then
     J:=X;
  //  Diagonaal: \
  For Y:=0 to Rows-4 do
   For X:=0 to Columns-4 do
    Begin
     If (FindFirstFree(X)=Y)and(fGrid[X+1,Y+1]=W)and(fGrid[X+2,Y+2]=W)and(fGrid[X+3,Y+3]=W) then
      J:=X;
     If (FindFirstFree(X+1)=Y+1)and(fGrid[X,Y]=W)and(fGrid[X+2,Y+2]=W)and(fGrid[X+3,Y+3]=W) then
      J:=X+1;
     If (FindFirstFree(X+2)=Y+2)and(fGrid[X+1,Y+1]=W)and(fGrid[X,Y]=W)and(fGrid[X+3,Y+3]=W) then
      J:=X+2;
     If (FindFirstFree(X+3)=Y+3)and(fGrid[X+1,Y+1]=W)and(fGrid[X+2,Y+2]=W)and(fGrid[X,Y]=W) then
      J:=X+3;
    End;
//  Diagonaal: /
  For Y:=3 to Rows-1 do
   For X:=0 to Columns-4 do
    Begin
     If (FindFirstFree(X)=Y)and(fGrid[X+1,Y-1]=W)and(fGrid[X+2,Y-2]=W)and(fGrid[X+3,Y-3]=W) then
      J:=X;
     If (FindFirstFree(X+1)=Y-1)and(fGrid[X,Y]=W)and(fGrid[X+2,Y-2]=W)and(fGrid[X+3,Y-3]=W) then
      J:=X+1;
     If (FindFirstFree(X+2)=Y-2)and(fGrid[X+1,Y-1]=W)and(fGrid[X,Y]=W)and(fGrid[X+3,Y-3]=W) then
      J:=X+2;
     If (FindFirstFree(X+3)=Y-3)and(fGrid[X+1,Y-1]=W)and(fGrid[X+2,Y-2]=W)and(fGrid[X,Y]=W) then
      J:=X+3;
    End;
  Result:=J;
 End;

FUNCTION TF4.PositionStatus(X,Y:INTEGER;K:TCOLOR):INTEGER;
 BEGIN
  IF (X IN [0..COLUMNS]) AND (Y IN [0..ROWS]) THEN
   BEGIN
    IF FGRID[X,Y]=FBACKCOLOR THEN
     BEGIN
      RESULT:=1; // IS FREE
      IF FINDFIRSTFREE(X)=Y THEN
       RESULT:=2; // IS FREE AND AVAILABLE
     END
    ELSE
     IF FGRID[X,Y]=K THEN
      RESULT:=0 // SAME COLOR
     ELSE
      RESULT:=-1; // OTHER COLOR
   END
  ELSE
   RESULT:=-2;//OUT OF SCREEN
 END;

Function TF4.Find2(W,OTHER,OUR:TCOLOR):Integer;  //W IS THE COLOR TO SEARCH
                                                 //OTHER IS THE COLOR OF THE OTHER PLAYER
                                                 //OUR IS THE CPU COLOR
 Var
  U:ARRAY[0..COLUMNS-1] OF INTEGER;
  MAX,X,Y,J:Integer;
 Begin
  FOR X:=0 TO COLUMNS-1 DO
   U[X]:=0;
  //  verticaal
  For Y:=1 to Rows-4 do
   For X:=0 to Columns-1 do
    If (FindFirstFree(X)=Y)and(fGrid[X,Y+1]=W)and(fGrid[X,Y+2]=W)AND(fGrid[X,Y-1]=FBACKCOLOR) then
     INC(U[X]);
  //  Horizontaal
  For Y:=0 to Rows-1 do
   For X:=0 to Columns-1 do
    Begin
     // XX
     IF (POSITIONSTATUS(X,Y,W)=0) AND (POSITIONSTATUS(X+1,Y,W)=0) THEN
      BEGIN
       //XX**
       IF (POSITIONSTATUS(X+2,Y,W)>0) AND (POSITIONSTATUS(X+3,Y,W)>0) THEN //XX??
        BEGIN
         IF POSITIONSTATUS(X+2,Y,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X+3,Y,W)=2 THEN
          INC(U[X+3]);
        END;
       //*XX*
       IF (POSITIONSTATUS(X+2,Y,W)>0) AND (POSITIONSTATUS(X-1,Y,W)>0) THEN //?XX?
        BEGIN
         IF POSITIONSTATUS(X+2,Y,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X-1,Y,W)=2 THEN
          INC(U[X-1]);
        END;
       //**XX
       IF (POSITIONSTATUS(X-2,Y,W)>0) AND (POSITIONSTATUS(X-1,Y,W)>0) THEN //??XX
        BEGIN
         IF POSITIONSTATUS(X-2,Y,W)=2 THEN
          INC(U[X-2]);
         IF POSITIONSTATUS(X-1,Y,W)=2 THEN
          INC(U[X-1]);
        END;
      END;
     //X*X
     IF (POSITIONSTATUS(X,Y,W)=0) AND (POSITIONSTATUS(X+2,Y,W)=0) THEN
      BEGIN
       //?X?X?
       //IS ? FREE (ALMOST 2)
       IF (POSITIONSTATUS(X+1,Y,W)>0) AND ((POSITIONSTATUS(X-1,Y,W)>0) OR (POSITIONSTATUS(X+3,Y,W)>0)) THEN
        BEGIN
         IF POSITIONSTATUS(X+1,Y,W)=2 THEN  //*X?X*
          INC(U[X+1]);
         IF POSITIONSTATUS(X-1,Y,W)=2 THEN  //?X*X*
          INC(U[X-1]);
         IF POSITIONSTATUS(X+3,Y,W)=2 THEN  //*X*X?
          INC(U[X+3]);
        END;
      END;
     //X**X
     IF (POSITIONSTATUS(X,Y,W)=0) AND (POSITIONSTATUS(X+3,Y,W)=0) THEN
      BEGIN
       //X??X
       IF (POSITIONSTATUS(X+1,Y,W)>0) AND (POSITIONSTATUS(X+2,Y,W)>0) THEN
        BEGIN
         IF POSITIONSTATUS(X+1,Y,W)=2 THEN  //X?*X
          INC(U[X+1]);
         IF POSITIONSTATUS(X+2,Y,W)=2 THEN  //X*?X
          INC(U[X+2]);
        END;
      END;
    End; //END HORIZONTAAL

  //  Diagonaal: \
  For Y:=0 to Rows-1 do
   For X:=0 to Columns-1 do
    Begin
     // XX
     IF (POSITIONSTATUS(X,Y,W)=0) AND (POSITIONSTATUS(X+1,Y+1,W)=0) THEN
      BEGIN
       //XX**
       IF (POSITIONSTATUS(X+2,Y+2,W)>0) AND (POSITIONSTATUS(X+3,Y+3,W)>0) THEN //XX??
        BEGIN
         IF POSITIONSTATUS(X+2,Y+2,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X+3,Y+3,W)=2 THEN
          INC(U[X+3]);
        END;
       //*XX*
       IF (POSITIONSTATUS(X+2,Y+2,W)>0) AND (POSITIONSTATUS(X-1,Y-1,W)>0) THEN //?XX?
        BEGIN
         IF POSITIONSTATUS(X+2,Y+2,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X-1,Y-1,W)=2 THEN
          INC(U[X-1]);
        END;
       //**XX
       IF (POSITIONSTATUS(X-2,Y-2,W)>0) AND (POSITIONSTATUS(X-1,Y-1,W)>0) THEN //??XX
        BEGIN
         IF POSITIONSTATUS(X-2,Y-2,W)=2 THEN
          INC(U[X-2]);
         IF POSITIONSTATUS(X-1,Y-1,W)=2 THEN
          INC(U[X-1]);
        END;
      END;
     //X*X
     IF (POSITIONSTATUS(X,Y,W)=0) AND (POSITIONSTATUS(X+2,Y+2,W)=0) THEN
      BEGIN
       //?X?X?
       //IS ? FREE (ALMOST 2)
       IF (POSITIONSTATUS(X+1,Y+1,W)>0) AND ((POSITIONSTATUS(X-1,Y-1,W)>0) OR (POSITIONSTATUS(X+3,Y+3,W)>0)) THEN
        BEGIN
         IF POSITIONSTATUS(X+1,Y+1,W)=2 THEN  //*X?X*
          INC(U[X+1]);
         IF POSITIONSTATUS(X-1,Y-1,W)=2 THEN  //?X*X*
          INC(U[X-1]);
         IF POSITIONSTATUS(X+3,Y+3,W)=2 THEN  //*X*X?
          INC(U[X+3]);
        END;
      END;
     //X**X
     IF (POSITIONSTATUS(X,Y,W)=0) AND (POSITIONSTATUS(X+3,Y+3,W)=0) THEN
      BEGIN
       //X??X
       IF (POSITIONSTATUS(X+1,Y+1,W)>0) AND (POSITIONSTATUS(X+2,Y+2,W)>0) THEN
        BEGIN
         IF POSITIONSTATUS(X+1,Y+1,W)=2 THEN  //X?*X
          INC(U[X+1]);
         IF POSITIONSTATUS(X+2,Y+2,W)=2 THEN  //X*?X
          INC(U[X+2]);
        END;
      END;
    End; // END DIAGONAAL \
//  Diagonaal: /
  For Y:=0 to Rows-1 do
   For X:=0 to Columns-1 do
    Begin
     // XX
     IF (POSITIONSTATUS(X,Y,W)=0) AND (POSITIONSTATUS(X+1,Y-1,W)=0) THEN
      BEGIN
       //XX**
       IF (POSITIONSTATUS(X+2,Y-2,W)>0) AND (POSITIONSTATUS(X+3,Y-3,W)>0) THEN //XX??
        BEGIN
         IF POSITIONSTATUS(X+2,Y-2,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X+3,Y-3,W)=2 THEN
          INC(U[X+3]);
        END;
       //*XX*
       IF (POSITIONSTATUS(X+2,Y-2,W)>0) AND (POSITIONSTATUS(X-1,Y+1,W)>0) THEN //?XX?
        BEGIN
         IF POSITIONSTATUS(X+2,Y-2,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X-1,Y+1,W)=2 THEN
          INC(U[X-1]);
        END;
       //**XX
       IF (POSITIONSTATUS(X-2,Y+2,W)>0) AND (POSITIONSTATUS(X-1,Y+1,W)>0) THEN //??XX
        BEGIN
         IF POSITIONSTATUS(X-2,Y+2,W)=2 THEN
          INC(U[X-2]);
         IF POSITIONSTATUS(X-1,Y+1,W)=2 THEN
          INC(U[X-1]);
        END;
      END;
     //X*X
     IF (POSITIONSTATUS(X,Y,W)=0) AND (POSITIONSTATUS(X+2,Y-2,W)=0) THEN
      BEGIN
       //?X?X?
       //IS ? FREE (ALMOST 2)
       IF (POSITIONSTATUS(X+1,Y-1,W)>0) AND ((POSITIONSTATUS(X-1,Y+1,W)>0) OR (POSITIONSTATUS(X+3,Y-3,W)>0)) THEN
        BEGIN
         IF POSITIONSTATUS(X+1,Y-1,W)=2 THEN  //*X?X*
          INC(U[X+1]);
         IF POSITIONSTATUS(X-1,Y+1,W)=2 THEN  //?X*X*
          INC(U[X-1]);
         IF POSITIONSTATUS(X+3,Y-3,W)=2 THEN  //*X*X?
          INC(U[X+3]);
        END;
      END;
     //X**X
     IF (POSITIONSTATUS(X,Y,W)=0) AND (POSITIONSTATUS(X+3,Y-3,W)=0) THEN
      BEGIN
       //X??X
       IF (POSITIONSTATUS(X+1,Y-1,W)>0) AND (POSITIONSTATUS(X+2,Y-2,W)>0) THEN
        BEGIN
         IF POSITIONSTATUS(X+1,Y-1,W)=2 THEN  //X?*X
          INC(U[X+1]);
         IF POSITIONSTATUS(X+2,Y-2,W)=2 THEN  //X*?X
          INC(U[X+2]);
        END;
      END;
    End; // END DIAGONAAL /
  // OK, NOW WE HAVE FOUND ALL THE FREE AND AVAILABLE POSITION.
  // WE KNOW THAT WE CAN NOT WIN, SO WE MUST CHECK THAT THE OTHER PLAYER
  // CAN NOT WIN PUTTING THE PIECE OVER THE OUR...
  FOR X:=0 TO COLUMNS-1 DO
   IF U[X] > 0 THEN
    IF MAYWIN(X,OTHER) THEN
     U[X]:=-100;
  // SEARCH IF YOU CAN LET YOU WIN NEXT TIME...
  FOR X:=0 TO COLUMNS-1 DO
   IF U[X] > 0 THEN
    IF MAYWIN(X,OUR) THEN
     U[X]:=10;
  J:=-1;//Not Found...
  MAX:=0;
  //FIND THE HIGH VALUE
  FOR X:=0 TO COLUMNS-1 DO
   IF U[X] > 0 THEN
    IF U[X]>MAX THEN
     MAX:=U[X];
  //RANDOM CHOOSE BEETWEEN THE HIGHEST VALUE
  IF MAX>0 THEN //WAS FOUND A NICE POSITION
   REPEAT
    J:=RANDOM(COLUMNS);
   UNTIL U[J]=MAX;
  Result:=J;
 End;

Function TF4.Find1(W,OTHER,OUR:TCOLOR):Integer;  //W IS THE COLOR TO SEARCH
                                                 //OTHER IS THE COLOR OF THE OTHER PLAYER
                                                 //OUR IS THE CPU COLOR
 Var
  U:ARRAY[0..COLUMNS-1] OF INTEGER;
  MAX,X,Y,J:Integer;
 Begin
  FOR X:=0 TO COLUMNS-1 DO
   U[X]:=0;
  //  Horizontaal
  For Y:=0 to Rows-1 do
   For X:=0 to Columns-1 do
    Begin
     IF (POSITIONSTATUS(X,Y,W)=0) THEN
      BEGIN
       //X***
       IF (POSITIONSTATUS(X+2,Y,W)>0) AND (POSITIONSTATUS(X+3,Y,W)>0)AND (POSITIONSTATUS(X+1,Y,W)>0) THEN //XX??
        BEGIN
         IF POSITIONSTATUS(X+1,Y,W)=2 THEN
          INC(U[X+1]);
         IF POSITIONSTATUS(X+2,Y,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X+3,Y,W)=2 THEN
          INC(U[X+3]);
        END;
       //*X**
       IF (POSITIONSTATUS(X+2,Y,W)>0) AND (POSITIONSTATUS(X+1,Y,W)>0) AND (POSITIONSTATUS(X-1,Y,W)>0) THEN //?XX?
        BEGIN
         IF POSITIONSTATUS(X+1,Y,W)=2 THEN
          INC(U[X+1]);
         IF POSITIONSTATUS(X+2,Y,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X-1,Y,W)=2 THEN
          INC(U[X-1]);
        END;
       //**X*
       IF (POSITIONSTATUS(X-2,Y,W)>0) AND (POSITIONSTATUS(X-1,Y,W)>0)And (POSITIONSTATUS(X+1,Y,W)>0) THEN //??XX
        BEGIN
         IF POSITIONSTATUS(X+1,Y,W)=2 THEN
          INC(U[X+1]);
         IF POSITIONSTATUS(X-2,Y,W)=2 THEN
          INC(U[X-2]);
         IF POSITIONSTATUS(X-1,Y,W)=2 THEN
          INC(U[X-1]);
        END;
       //***X
       IF (POSITIONSTATUS(X-2,Y,W)>0) AND (POSITIONSTATUS(X-1,Y,W)>0)And (POSITIONSTATUS(X-3,Y,W)>0) THEN //??XX
        BEGIN
         IF POSITIONSTATUS(X-3,Y,W)=2 THEN
          INC(U[X-3]);
         IF POSITIONSTATUS(X-2,Y,W)=2 THEN
          INC(U[X-2]);
         IF POSITIONSTATUS(X-1,Y,W)=2 THEN
          INC(U[X-1]);
        END;
      END;
    End; //END HORIZONTAAL

  //  Diagonaal: \
  For Y:=0 to Rows-1 do
   For X:=0 to Columns-1 do
    Begin
     IF (POSITIONSTATUS(X,Y,W)=0) THEN
      BEGIN
       //X***
       IF (POSITIONSTATUS(X+2,Y-2,W)>0) AND (POSITIONSTATUS(X+3,Y-3,W)>0)AND (POSITIONSTATUS(X+1,Y-1,W)>0) THEN //XX??
        BEGIN
         IF POSITIONSTATUS(X+1,Y-1,W)=2 THEN
          INC(U[X+1]);
         IF POSITIONSTATUS(X+2,Y-2,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X+3,Y-3,W)=2 THEN
          INC(U[X+3]);
        END;
       //*X**
       IF (POSITIONSTATUS(X+2,Y-2,W)>0) AND (POSITIONSTATUS(X+1,Y-1,W)>0) AND (POSITIONSTATUS(X-1,Y+1,W)>0) THEN //?XX?
        BEGIN
         IF POSITIONSTATUS(X+1,Y-1,W)=2 THEN
          INC(U[X+1]);
         IF POSITIONSTATUS(X+2,Y-2,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X-1,Y+1,W)=2 THEN
          INC(U[X-1]);
        END;
       //**X*
       IF (POSITIONSTATUS(X-2,Y+2,W)>0) AND (POSITIONSTATUS(X-1,Y+1,W)>0)And (POSITIONSTATUS(X+1,Y-1,W)>0) THEN //??XX
        BEGIN
         IF POSITIONSTATUS(X+1,Y-1,W)=2 THEN
          INC(U[X+1]);
         IF POSITIONSTATUS(X-2,Y+2,W)=2 THEN
          INC(U[X-2]);
         IF POSITIONSTATUS(X-1,Y+1,W)=2 THEN
          INC(U[X-1]);
        END;
       //***X
       IF (POSITIONSTATUS(X-2,Y+2,W)>0) AND (POSITIONSTATUS(X-1,Y+1,W)>0)And (POSITIONSTATUS(X-3,Y+3,W)>0) THEN //??XX
        BEGIN
         IF POSITIONSTATUS(X-3,Y+3,W)=2 THEN
          INC(U[X-3]);
         IF POSITIONSTATUS(X-2,Y+2,W)=2 THEN
          INC(U[X-2]);
         IF POSITIONSTATUS(X-1,Y+1,W)=2 THEN
          INC(U[X-1]);
        END;
      END;
    End; // END DIAGONAAL \
//  Diagonaal: /
  For Y:=0 to Rows-1 do
   For X:=0 to Columns-1 do
    Begin
     IF (POSITIONSTATUS(X,Y,W)=0) THEN
      BEGIN
       //X***
       IF (POSITIONSTATUS(X+2,Y+2,W)>0) AND (POSITIONSTATUS(X+3,Y+3,W)>0)AND (POSITIONSTATUS(X+1,Y+1,W)>0) THEN //XX??
        BEGIN
         IF POSITIONSTATUS(X+1,Y+1,W)=2 THEN
          INC(U[X+1]);
         IF POSITIONSTATUS(X+2,Y+2,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X+3,Y+3,W)=2 THEN
          INC(U[X+3]);
        END;
       //*X**
       IF (POSITIONSTATUS(X+2,Y+2,W)>0) AND (POSITIONSTATUS(X+1,Y+1,W)>0) AND (POSITIONSTATUS(X-1,Y-1,W)>0) THEN //?XX?
        BEGIN
         IF POSITIONSTATUS(X+1,Y+1,W)=2 THEN
          INC(U[X+1]);
         IF POSITIONSTATUS(X+2,Y+2,W)=2 THEN
          INC(U[X+2]);
         IF POSITIONSTATUS(X-1,Y-1,W)=2 THEN
          INC(U[X-1]);
        END;
       //**X*
       IF (POSITIONSTATUS(X-2,Y-2,W)>0) AND (POSITIONSTATUS(X-1,Y-1,W)>0)And (POSITIONSTATUS(X+1,Y+1,W)>0) THEN //??XX
        BEGIN
         IF POSITIONSTATUS(X+1,Y+1,W)=2 THEN
          INC(U[X+1]);
         IF POSITIONSTATUS(X-2,Y-2,W)=2 THEN
          INC(U[X-2]);
         IF POSITIONSTATUS(X-1,Y-1,W)=2 THEN
          INC(U[X-1]);
        END;
       //***X
       IF (POSITIONSTATUS(X-2,Y-2,W)>0) AND (POSITIONSTATUS(X-1,Y-1,W)>0)And (POSITIONSTATUS(X-3,Y-3,W)>0) THEN //??XX
        BEGIN
         IF POSITIONSTATUS(X-3,Y-3,W)=2 THEN
          INC(U[X-3]);
         IF POSITIONSTATUS(X-2,Y-2,W)=2 THEN
          INC(U[X-2]);
         IF POSITIONSTATUS(X-1,Y-1,W)=2 THEN
          INC(U[X-1]);
        END;
      END;
    End; // END DIAGONAAL /
  // OK, NOW WE HAVE FOUND ALL THE FREE AND AVAILABLE POSITION.
  // WE KNOW THAT WE CAN NOT WIN, SO WE MUST CHECK THAT THE OTHER PLAYER
  // CAN NOT WIN PUTTING THE PIECE OVER THE OUR...
  FOR X:=0 TO COLUMNS-1 DO
   IF U[X] > 0 THEN
    IF MAYWIN(X,OTHER) THEN
     U[X]:=-100;
  // SEARCH IF YOU CAN LET YOU WIN NEXT TIME...
  FOR X:=0 TO COLUMNS-1 DO
   IF U[X] > 0 THEN
    IF MAYWIN(X,OUR) THEN
     U[X]:=10;
  J:=-1;//Not Found...
  MAX:=0;
  //FIND THE HIGH VALUE
  FOR X:=0 TO COLUMNS-1 DO
   IF U[X] > 0 THEN
    IF U[X]>MAX THEN
     MAX:=U[X];
  //RANDOM CHOOSE BEETWEEN THE HIGHEST VALUE
  IF MAX>0 THEN //WAS FOUND A NICE POSITION
   REPEAT
    J:=RANDOM(COLUMNS);
   UNTIL U[J]=MAX;
  Result:=J;
 End;


FUNCTION TF4.MAYWIN(M:INTEGER;C:TCOLOR):BOOLEAN; //TRUE IF COL WIN
 VAR
  J:BOOLEAN;
  Y:INTEGER;
 BEGIN
  J:=FALSE;
  Y:=FINDFIRSTFREE(M)-1;
  IF Y IN [0..COLUMNS] THEN
   BEGIN
    //HORIZONTAAL
    //X???
    IF (POSITIONSTATUS(M+3,Y,C)=0)AND(POSITIONSTATUS(M+1,Y,C)=0)AND(POSITIONSTATUS(M+2,Y,C)=0) THEN
     J:=TRUE;
    //?X??
    IF (POSITIONSTATUS(M-1,Y,C)=0)AND(POSITIONSTATUS(M+1,Y,C)=0)AND(POSITIONSTATUS(M+2,Y,C)=0) THEN
     J:=TRUE;
    //??X?
    IF (POSITIONSTATUS(M-2,Y,C)=0)AND(POSITIONSTATUS(M-1,Y,C)=0)AND(POSITIONSTATUS(M+1,Y,C)=0) THEN
     J:=TRUE;
    //???X
    IF (POSITIONSTATUS(M-3,Y,C)=0)AND(POSITIONSTATUS(M-1,Y,C)=0)AND(POSITIONSTATUS(M-2,Y,C)=0) THEN
     J:=TRUE;
    //DIAGONAAL  \
    //X???
    IF (POSITIONSTATUS(M+3,Y+3,C)=0)AND(POSITIONSTATUS(M+1,Y+1,C)=0)AND(POSITIONSTATUS(M+2,Y+2,C)=0) THEN
     J:=TRUE;
    //?X??
    IF (POSITIONSTATUS(M-1,Y-1,C)=0)AND(POSITIONSTATUS(M+1,Y+1,C)=0)AND(POSITIONSTATUS(M+2,Y+2,C)=0) THEN
     J:=TRUE;
    //??X?
    IF (POSITIONSTATUS(M-2,Y-2,C)=0)AND(POSITIONSTATUS(M-1,Y-1,C)=0)AND(POSITIONSTATUS(M+1,Y+1,C)=0) THEN
     J:=TRUE;
    //???X
    IF (POSITIONSTATUS(M-3,Y-3,C)=0)AND(POSITIONSTATUS(M-1,Y-1,C)=0)AND(POSITIONSTATUS(M-2,Y-2,C)=0) THEN
     J:=TRUE;
    //DIAGONAAL  /
    //X???
    IF (POSITIONSTATUS(M+3,Y-3,C)=0)AND(POSITIONSTATUS(M+1,Y-1,C)=0)AND(POSITIONSTATUS(M+2,Y-2,C)=0) THEN
     J:=TRUE;
    //?X??
    IF (POSITIONSTATUS(M-1,Y+1,C)=0)AND(POSITIONSTATUS(M+1,Y-1,C)=0)AND(POSITIONSTATUS(M+2,Y-2,C)=0) THEN
     J:=TRUE;
    //??X?
    IF (POSITIONSTATUS(M-2,Y+2,C)=0)AND(POSITIONSTATUS(M-1,Y+1,C)=0)AND(POSITIONSTATUS(M+1,Y-1,C)=0) THEN
     J:=TRUE;
    //???X
    IF (POSITIONSTATUS(M-3,Y+3,C)=0)AND(POSITIONSTATUS(M-1,Y+1,C)=0)AND(POSITIONSTATUS(M-2,Y+2,C)=0) THEN
     J:=TRUE;
   END; //Y IN ...
  RESULT:=J;
 END;

Function TF4.RandomPosition:Integer;
 Var
  A:Integer;
 Begin
  Repeat
   A:=Random(Columns);
  Until FindFirstFree(A)>-1;
  Result:=A;
 End;
